#include "chdecl.h"
void CH_chcode_chphase3(current, sched, cop)
#define ARGUMENTS 9
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb3;
    case 2: goto c4;
    case 3: goto cb6;
    case 4: goto c7;
    case 5: goto cb11;
    case 6: goto c12;
    case 7: goto c18;
    case 8: goto c42;
    case 9: goto c57;
    case 10: goto c69;
    case 11: goto c79;
    case 12: goto c92;
    case 13: goto c107;
    case 14: goto c131;
    case 15: goto c139;
    case 16: goto c141;
    case 17: goto cb160;
    case 18: goto c161;
    case 19: goto cb176;
    case 20: goto c177;
    case 21: goto c185;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
/* ilit 3 , 3 */
  REF(3).value.integer = 3;
  REF(3).tsdr = & dr_integer;
  current->ip = 1;
cb3:
/* receive 4 0 */
  if ((ch_returncode = che_receive(DEF(4),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c4:
/* branch_false 4.0.9.0 , 7 */
  if ( !REF(4)DOT(0)DOT(9)DOT(0).value.boolean ) goto c7;
/* chs_lit 5 , "phase3 " */
  if( !chs_lit(DEF(5),"phase3 ") ) goto ch_depletion;
  current->ip = 3;
cb6:
/* call 4.0.4 5 , 1 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(4)DOT(0)DOT(4),
          arguments[1] = DEF(5),
          arguments[1+1] = nil,& arguments[0]),QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  return;
c7:
/* discard 5 */
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  REF(5).tsdr = & dr_bottom;
/* prog_lit 6 , 2 */
  if ((ch_returncode = che_prog_lit(DEF(6),QUAL(2),sched)) != Normal) 
     goto ch_raise_exception;
/* create 7 6 , 3 */
  if ((ch_returncode = che_create(DEF(7),DEF(6),QUAL(3),sched)) != Normal)
     goto ch_raise_exception;
/* discard 6 */
  (*(REF(6).tsdr)->finalize)(REF(6).value,F_DISCARD,sched);
  REF(6).tsdr = & dr_bottom;
  current->ip = 5;
cb11:
/* call 7 4.2 4.4 , 4 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(7),
          arguments[1] = DEF(4)DOT(2),
          arguments[2] = DEF(4)DOT(4),
          arguments[2+1] = nil,& arguments[0]),QUAL(4),sched)) != Normal)
     goto ch_raise_exception;
  return;
c12:
/* new_table 8 , 5 */
  if ((ch_returncode = che_new_table(DEF(8),QUAL(5),sched)) != Normal) 
     goto ch_raise_exception;
/* new_record 9 , 2 */
  if ((ch_val.record = new_record(2)) == nil) goto ch_depletion;
  (*(REF(9).tsdr)->finalize)(REF(9).value,F_DISCARD,sched);
  REF(9).value = ch_val; REF(9).tsdr = & dr_record;
/* copy 10 3 */
  REF(10) = REF(3);
/* copy 9.1 10 */
  REF(9)DOT(1) = REF(10);
/* copy 11 4.3 */
  if((ch_returncode = cp_table(& ch_val, REF(4)DOT(3).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(11).tsdr)->finalize)(REF(11).value,F_DISCARD,sched);
  REF(11).value = ch_val;
  REF(11).tsdr = & dr_table;
/* initget 12 11 , 0,0 */
  (*(REF(12).tsdr)->finalize)(REF(12).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(12),DEF(11),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c18:
/* get_or_goto 12 11 , 69 */
  if ((ch_returncode = get_selected_object(DEF(12),DEF(11),sched)) != Normal)
     goto c69;
/* lookup_at 13 12.0 =(0) */
  if ( !((ch_t = REF(12)DOT(0).value.table)->size) ) goto ch_notfound;
  (*(REF(13).tsdr)->finalize)(REF(13).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(13).value,0);
  REF(13).tsdr = qdatarepmap[ch_t->tsdr->number];
/* copy 14 13 */
  REF(14) = REF(13);
/* ilt . 14 3 , 18 */
  if ( REF(14).value.integer < 3 ) goto c18;
/* position 15 12 */
  ch_frame = get_selector_frame(DEF(12),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(15).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(15).tsdr = &dr_integer;
/* iadd 16 12.3 12.2 */
  if (!chf_iadd(DEF(16),REF(12)DOT(3).value.integer,
    REF(12)DOT(2).value.integer)) goto ch_depletion;
/* ile . 16 =(0) , 57 */
  if ( REF(16).value.integer <= 0 ) goto c57;
/* lookup_at 17 12.0 =(0) */
  if ( !((ch_t = REF(12)DOT(0).value.table)->size) ) goto ch_notfound;
  (*(REF(17).tsdr)->finalize)(REF(17).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(17).value,0);
  REF(17).tsdr = qdatarepmap[ch_t->tsdr->number];
/* copy 9.0 17 */
  if((ch_returncode = (REF(17).tsdr->copy)(& ch_val, REF(17).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(9)DOT(0).tsdr)->finalize)(REF(9)DOT(0).value,F_DISCARD,sched);
  REF(9)DOT(0).value = ch_val;
  REF(9)DOT(0).tsdr = datarepmap[REF(17).tsdr->number];
/* block , 6 */
  if((ch_returncode = che_block(QUAL(6),sched)) != Normal)
     goto ch_raise_exception;
/* insert 8 9 */
  if ((ch_returncode = insertfunc(DEF(8),DEF(9),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* new_record 9 , 2 */
  if ((ch_val.record = new_record(2)) == nil) goto ch_depletion;
  (*(REF(9).tsdr)->finalize)(REF(9).value,F_DISCARD,sched);
  REF(9).value = ch_val; REF(9).tsdr = & dr_record;
/* iadd 10 10 =(1) */
  if (!chf_iadd(DEF(10),REF(10).value.integer,1)) goto ch_depletion;
/* copy 9.1 10 */
  REF(9)DOT(1) = REF(10);
/* endblock */
  che_endblock(sched);
c42:
/* find 18 8 17 , 0 */
  if (findfunc(DEF(18),DEF(8),(
          arguments[0] = DEF(17),& arguments[0]),sched,0) == FAILURE)
             goto ch_notfound;
/* equal . 18.0 18.1 , 18 */
  if ( (REF(18)DOT(0).tsdr->equal)(REF(18)DOT(0).value,REF(18)DOT(1).value) )
     goto c18;
/* privatize 4.3 */
  if (REF(4)DOT(3).value.table->refcount != 1)
    if ((ch_returncode = doCopyOnWrite(DEF(4)DOT(3))) != Normal)
       goto ch_raise_exception;
/* lookup_at 19 4.3 15 */
  if((ch_i = REF(15).value.integer) < 0 || ch_i >= (ch_t = REF(4)DOT(3).value
    .table)->size) goto ch_notfound;
  (*(REF(19).tsdr)->finalize)(REF(19).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(19).value,ch_i);
  REF(19).tsdr = qdatarepmap[ch_t->tsdr->number];
/* remove_at 20 4.3 15 */
  if ((ch_returncode = remove_at_func(DEF(20),DEF(4)DOT(3),
    REF(15).value.integer)) != Normal) goto ch_raise_exception;
/* privatize 20.0 */
  if (REF(20)DOT(0).value.table->refcount != 1)
    if ((ch_returncode = doCopyOnWrite(DEF(20)DOT(0))) != Normal)
       goto ch_raise_exception;
/* lookup_at 21 20.0 =(0) */
  if ( !((ch_t = REF(20)DOT(0).value.table)->size) ) goto ch_notfound;
  (*(REF(21).tsdr)->finalize)(REF(21).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(21).value,0);
  REF(21).tsdr = qdatarepmap[ch_t->tsdr->number];
/* remove_at 22 20.0 =(0) */
  if ((ch_returncode = remove_at_func(DEF(22),DEF(20)DOT(0),0)) != Normal)
     goto ch_raise_exception;
/* copy 23 18.1 */
  if((ch_returncode = (REF(18)DOT(1).tsdr->copy)(& ch_val, REF(18)DOT(1).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(23).tsdr)->finalize)(REF(23).value,F_DISCARD,sched);
  REF(23).value = ch_val;
  REF(23).tsdr = datarepmap[REF(18)DOT(1).tsdr->number];
/* insert_at 20.0 23 =(0) */
  if ((ch_returncode = insertfunc(DEF(20)DOT(0),DEF(23),TRUE, 0)) != Normal)
     goto ch_raise_exception;
/* insert_at 4.3 20 15 */
  ch_i = REF(15).value.integer;
  if (ch_i < 0 || REF(4)DOT(3).value.table->size < ch_i) goto ch_range_error;
  if ((ch_returncode = insertfunc(DEF(4)DOT(3),DEF(20),TRUE, ch_i)) != Normal)
     goto ch_raise_exception;
/* branch , 18 */
   goto c18;
c57:
/* privatize 4.3 */
  if (REF(4)DOT(3).value.table->refcount != 1)
    if ((ch_returncode = doCopyOnWrite(DEF(4)DOT(3))) != Normal)
       goto ch_raise_exception;
/* lookup_at 24 4.3 15 */
  if((ch_i = REF(15).value.integer) < 0 || ch_i >= (ch_t = REF(4)DOT(3).value
    .table)->size) goto ch_notfound;
  (*(REF(24).tsdr)->finalize)(REF(24).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(24).value,ch_i);
  REF(24).tsdr = qdatarepmap[ch_t->tsdr->number];
/* remove_at 20 4.3 15 */
  if ((ch_returncode = remove_at_func(DEF(20),DEF(4)DOT(3),
    REF(15).value.integer)) != Normal) goto ch_raise_exception;
/* privatize 20.0 */
  if (REF(20)DOT(0).value.table->refcount != 1)
    if ((ch_returncode = doCopyOnWrite(DEF(20)DOT(0))) != Normal)
       goto ch_raise_exception;
/* lookup_at 25 20.0 =(0) */
  if ( !((ch_t = REF(20)DOT(0).value.table)->size) ) goto ch_notfound;
  (*(REF(25).tsdr)->finalize)(REF(25).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(25).value,0);
  REF(25).tsdr = qdatarepmap[ch_t->tsdr->number];
/* remove_at 22 20.0 =(0) */
  if ((ch_returncode = remove_at_func(DEF(22),DEF(20)DOT(0),0)) != Normal)
     goto ch_raise_exception;
/* inegate 26 15 */
  REF(26).value.integer = -REF(15).value.integer;
  REF(26).tsdr = & dr_integer;
/* insert_at 20.0 26 =(0) */
  if ((ch_returncode = insertfunc(DEF(20)DOT(0),DEF(26),TRUE, 0)) != Normal)
     goto ch_raise_exception;
/* insert_at 4.3 20 15 */
  ch_i = REF(15).value.integer;
  if (ch_i < 0 || REF(4)DOT(3).value.table->size < ch_i) goto ch_range_error;
  if ((ch_returncode = insertfunc(DEF(4)DOT(3),DEF(20),TRUE, ch_i)) != Normal)
     goto ch_raise_exception;
/* branch , 18 */
   goto c18;
c69:
/* endget 12 11 */
  end_selector(DEF(12),DEF(11),sched,GET);
/* discard 11 */
  (*(REF(11).tsdr)->finalize)(REF(11).value,F_DISCARD,sched);
  REF(11).tsdr = & dr_bottom;
/* move 4.5.1 10 */
  REF(4)DOT(5)DOT(1) = REF(10);
  REF(10).tsdr = & dr_bottom;
/* new_table 27 , 7 */
  if ((ch_returncode = che_new_table(DEF(27),QUAL(7),sched)) != Normal) 
     goto ch_raise_exception;
/* boolean 28 , FALSE */
  REF(28).value.boolean = FALSE;
  REF(28).tsdr = & dr_boolean;
/* ilit 29 , 1 */
  REF(29).value.integer = 1;
  REF(29).tsdr = & dr_integer;
/* copy 30 4.2 */
  if((ch_returncode = cp_table(& ch_val, REF(4)DOT(2).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(30).tsdr)->finalize)(REF(30).value,F_DISCARD,sched);
  REF(30).value = ch_val;
  REF(30).tsdr = & dr_table;
/* initget 31 30 , 0,0 */
  (*(REF(31).tsdr)->finalize)(REF(31).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(31),DEF(30),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c79:
/* get_or_goto 31 30 , 141 */
  if ((ch_returncode = get_selected_object(DEF(31),DEF(30),sched)) != Normal)
     goto c141;
/* discard 32 */
  (*(REF(32).tsdr)->finalize)(REF(32).value,F_DISCARD,sched);
  REF(32).tsdr = & dr_bottom;
/* copy 32 31 */
  if((ch_returncode = (REF(31).tsdr->copy)(& ch_val, REF(31).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(32).tsdr)->finalize)(REF(32).value,F_DISCARD,sched);
  REF(32).value = ch_val;
  REF(32).tsdr = datarepmap[REF(31).tsdr->number];
/* notequal . 32.4 =(0) , 107 */
  if ( REF(32)DOT(4).value.ord_enum != 0 ) goto c107;
/* boolean 28 , TRUE */
  REF(28).value.boolean = TRUE;
  REF(28).tsdr = & dr_boolean;
/* new_record 33 , 3 */
  if ((ch_val.record = new_record(3)) == nil) goto ch_depletion;
  (*(REF(33).tsdr)->finalize)(REF(33).value,F_DISCARD,sched);
  REF(33).value = ch_val; REF(33).tsdr = & dr_record;
/* move 33.0 32.0 */
  REF(33)DOT(0) = REF(32)DOT(0);
  REF(32)DOT(0).tsdr = & dr_bottom;
/* new_table 33.1 , 7 */
  if ((ch_returncode = che_new_table(DEF(33)DOT(1),QUAL(7),sched)) != Normal) 
     goto ch_raise_exception;
/* copy 34 32.1 */
  if((ch_returncode = cp_table(& ch_val, REF(32)DOT(1).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(34).tsdr)->finalize)(REF(34).value,F_DISCARD,sched);
  REF(34).value = ch_val;
  REF(34).tsdr = & dr_table;
/* initget 35 34 , 0,0 */
  (*(REF(35).tsdr)->finalize)(REF(35).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(35),DEF(34),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c92:
/* get_or_goto 35 34 , 102 */
  if ((ch_returncode = get_selected_object(DEF(35),DEF(34),sched)) != Normal)
     goto c102;
/* notequal . 35 =(-1) , 98 */
  if ( REF(35).value.integer != -1 ) goto c98;
/* new_table 36 , 7 */
  if ((ch_returncode = che_new_table(DEF(36),QUAL(7),sched)) != Normal) 
     goto ch_raise_exception;
/* branch , 100 */
   goto c100;
c98:
/* lookup_at 37 4.3 35 */
  if((ch_i = REF(35).value.integer) < 0 || ch_i >= (ch_t = REF(4)DOT(3).value
    .table)->size) goto ch_notfound;
  (*(REF(37).tsdr)->finalize)(REF(37).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(37).value,ch_i);
  REF(37).tsdr = qdatarepmap[ch_t->tsdr->number];
/* copy 36 37.0 */
  if((ch_returncode = cp_table(& ch_val, REF(37)DOT(0).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(36).tsdr)->finalize)(REF(36).value,F_DISCARD,sched);
  REF(36).value = ch_val;
  REF(36).tsdr = & dr_table;
c100:
/* insert 33.1 36 */
  if ((ch_returncode = insertfunc(DEF(33)DOT(1),DEF(36),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 92 */
   goto c92;
c102:
/* endget 35 34 */
  end_selector(DEF(35),DEF(34),sched,GET);
/* discard 34 */
  (*(REF(34).tsdr)->finalize)(REF(34).value,F_DISCARD,sched);
  REF(34).tsdr = & dr_bottom;
/* move 33.2 32.2 */
  (*(REF(33)DOT(2).tsdr)->finalize)(REF(33)DOT(2).value,F_DISCARD,sched);
  REF(33)DOT(2) = REF(32)DOT(2);
  REF(32)DOT(2).tsdr = & dr_bottom;
/* insert 27 33 */
  if ((ch_returncode = insertfunc(DEF(27),DEF(33),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 139 */
   goto c139;
c107:
/* noop */
  
/* equal . 32.4 =(4) , 115 */
  if ( REF(32)DOT(4).value.ord_enum == 4 ) goto c115;
/* size 38 31.1 */
  REF(38).value.integer = REF(31)DOT(1).value.table->size;
  REF(38).tsdr = & dr_integer;
/* ile . 38 29 , 115 */
  if ( REF(38).value.integer <= REF(29).value.integer ) goto c115;
/* size 29 31.1 */
  REF(29).value.integer = REF(31)DOT(1).value.table->size;
  REF(29).tsdr = & dr_integer;
c115:
/* noop */
  
/* oele 39 32.4 =(2) */
  REF(39).value.boolean = (REF(32)DOT(4).value.ord_enum <= 2);
/* equal 40 32.4 =(4) */
  REF(40).value.boolean = (REF(32)DOT(4).value.ord_enum == 4);
  REF(40).tsdr = & dr_boolean;
/* equal 41 32.0 =(113) */
  REF(41).value.boolean = (REF(32)DOT(0).value.enumeration == 113);
  REF(41).tsdr = & dr_boolean;
/* and 42 40 41 */
  REF(42).value.boolean = REF(40).value.boolean&REF(41).value.boolean;
  REF(42).tsdr = & dr_boolean;
/* or 43 39 42 */
  REF(43).value.boolean = REF(39).value.boolean|REF(42).value.boolean;
  REF(43).tsdr = & dr_boolean;
/* branch_false 43 , 139 */
  if ( !REF(43).value.boolean ) goto c139;
/* new_record 33 , 3 */
  if ((ch_val.record = new_record(3)) == nil) goto ch_depletion;
  (*(REF(33).tsdr)->finalize)(REF(33).value,F_DISCARD,sched);
  REF(33).value = ch_val; REF(33).tsdr = & dr_record;
/* enum_lit 33.0 , 113 */
  REF(33)DOT(0).value.enumeration = 113;
  REF(33)DOT(0).tsdr = & dr_enumeration;
/* new_table 33.1 , 7 */
  if ((ch_returncode = che_new_table(DEF(33)DOT(1),QUAL(7),sched)) != Normal) 
     goto ch_raise_exception;
/* position 44 31 */
  ch_frame = get_selector_frame(DEF(31),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(44).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(44).tsdr = &dr_integer;
/* initget 45 4.1 , 0,0 */
  (*(REF(45).tsdr)->finalize)(REF(45).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(45),DEF(4)DOT(1),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c131:
/* get_or_err 45 4.1 */
  if ((ch_returncode = get_selected_object(DEF(45),DEF(4)DOT(1)
    ,sched)) != Normal) goto ch_raise_exception;
/* notequal . 45.1 44 , 131 */
  if ( REF(45)DOT(1).value.integer != REF(44).value.integer ) goto c131;
/* position 46 45 */
  ch_frame = get_selector_frame(DEF(45),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(46).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(46).tsdr = &dr_integer;
/* unite 33.2 46 , 2 */
  if ((ch_returncode = che_unite(DEF(33)DOT(2),DEF(46),sched,2)) != Normal)
     goto ch_raise_exception;
/* endget 45 4.1 */
  end_selector(DEF(45),DEF(4)DOT(1),sched,GET);
/* insert 27 33 */
  if ((ch_returncode = insertfunc(DEF(27),DEF(33),FALSE,0)) != Normal)
     goto ch_raise_exception;
c139:
/* discard 32.2 */
  (*(REF(32)DOT(2).tsdr)->finalize)(REF(32)DOT(2).value,F_DISCARD,sched);
  REF(32)DOT(2).tsdr = & dr_bottom;
/* branch , 79 */
   goto c79;
c141:
/* endget 31 30 */
  end_selector(DEF(31),DEF(30),sched,GET);
/* discard 30 */
  (*(REF(30).tsdr)->finalize)(REF(30).value,F_DISCARD,sched);
  REF(30).tsdr = & dr_bottom;
/* move 4.5.3 27 */
  (*(REF(4)DOT(5)DOT(3).tsdr)->finalize)(REF(4)DOT(5)DOT(3).value
    ,F_DISCARD,sched);
  REF(4)DOT(5)DOT(3) = REF(27);
  REF(27).tsdr = & dr_bottom;
/* chs_lit 47 , "#include \"chdecl.h\"" */
  if( !chs_lit(DEF(47),"#include \"chdecl.h\"") ) goto ch_depletion;
/* ordenum_lit 48 , 10 */
  REF(48).value.ord_enum = 10;
  REF(48).tsdr = & dr_ord_enumeration;
/* insert 47 48 */
  if ((ch_returncode = insertfunc(DEF(47),DEF(48),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* chs_lit 49 , "void CH_" */
  if( !chs_lit(DEF(49),"void CH_") ) goto ch_depletion;
/* merge 47 49 */
  if ((ch_returncode = mergefunc(DEF(47),DEF(49),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* copy 50 4.5.4 */
  if((ch_returncode = cp_table(& ch_val, REF(4)DOT(5)DOT(4).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(50).tsdr)->finalize)(REF(50).value,F_DISCARD,sched);
  REF(50).value = ch_val;
  REF(50).tsdr = & dr_table;
/* merge 47 50 */
  if ((ch_returncode = mergefunc(DEF(47),DEF(50),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* chs_lit 51 , "(current, sched, cop)" */
  if( !chs_lit(DEF(51),"(current, sched, cop)") ) goto ch_depletion;
/* merge 47 51 */
  if ((ch_returncode = mergefunc(DEF(47),DEF(51),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* ordenum_lit 52 , 10 */
  REF(52).value.ord_enum = 10;
  REF(52).tsdr = & dr_ord_enumeration;
/* insert 47 52 */
  if ((ch_returncode = insertfunc(DEF(47),DEF(52),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* chs_lit 53 , "#define ARGUMENTS " */
  if( !chs_lit(DEF(53),"#define ARGUMENTS ") ) goto ch_depletion;
/* merge 47 53 */
  if ((ch_returncode = mergefunc(DEF(47),DEF(53),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* iadd 54 29 =(2) */
  if (!chf_iadd(DEF(54),REF(29).value.integer,2)) goto ch_depletion;
  current->ip = 17;
cb160:
/* call 4.0.12 54 55 , 8 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(4)DOT(0)DOT(12),
          arguments[1] = DEF(54),
          arguments[2] = DEF(55),
          arguments[2+1] = nil,& arguments[0]),QUAL(8),sched)) != Normal)
     goto ch_raise_exception;
  return;
c161:
/* merge 47 55 */
  if ((ch_returncode = mergefunc(DEF(47),DEF(55),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* ordenum_lit 56 , 10 */
  REF(56).value.ord_enum = 10;
  REF(56).tsdr = & dr_ord_enumeration;
/* insert 47 56 */
  if ((ch_returncode = insertfunc(DEF(47),DEF(56),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch_false 28 , 169 */
  if ( !REF(28).value.boolean ) goto c169;
/* chs_lit 57 , "#define INTERPRET" */
  if( !chs_lit(DEF(57),"#define INTERPRET") ) goto ch_depletion;
/* merge 47 57 */
  if ((ch_returncode = mergefunc(DEF(47),DEF(57),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* ordenum_lit 58 , 10 */
  REF(58).value.ord_enum = 10;
  REF(58).tsdr = & dr_ord_enumeration;
/* insert 47 58 */
  if ((ch_returncode = insertfunc(DEF(47),DEF(58),FALSE,0)) != Normal)
     goto ch_raise_exception;
c169:
/* chs_lit 59 , "#include \"chhead.h\"" */
  if( !chs_lit(DEF(59),"#include \"chhead.h\"") ) goto ch_depletion;
/* merge 47 59 */
  if ((ch_returncode = mergefunc(DEF(47),DEF(59),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* ordenum_lit 60 , 10 */
  REF(60).value.ord_enum = 10;
  REF(60).tsdr = & dr_ord_enumeration;
/* insert 47 60 */
  if ((ch_returncode = insertfunc(DEF(47),DEF(60),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* prog_lit 61 , 9 */
  if ((ch_returncode = che_prog_lit(DEF(61),QUAL(9),sched)) != Normal) 
     goto ch_raise_exception;
/* create 62 61 , 10 */
  if ((ch_returncode = che_create(DEF(62),DEF(61),QUAL(10),sched)) != Normal)
     goto ch_raise_exception;
/* discard 61 */
  (*(REF(61).tsdr)->finalize)(REF(61).value,F_DISCARD,sched);
  REF(61).tsdr = & dr_bottom;
  current->ip = 19;
cb176:
/* call 62 4.0 4.1 4.2 4.3 47 4.5.9 , 11 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(62),
          arguments[1] = DEF(4)DOT(0),
          arguments[2] = DEF(4)DOT(1),
          arguments[3] = DEF(4)DOT(2),
          arguments[4] = DEF(4)DOT(3),
          arguments[5] = DEF(47),
          arguments[6] = DEF(4)DOT(5)DOT(9),
          arguments[6+1] = nil,& arguments[0]),QUAL(11),sched)) != Normal)
     goto ch_raise_exception;
  return;
c177:
/* chs_lit 63 , "#include \"chtail.h\"" */
  if( !chs_lit(DEF(63),"#include \"chtail.h\"") ) goto ch_depletion;
/* merge 47 63 */
  if ((ch_returncode = mergefunc(DEF(47),DEF(63),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* ordenum_lit 64 , 10 */
  REF(64).value.ord_enum = 10;
  REF(64).tsdr = & dr_ord_enumeration;
/* insert 47 64 */
  if ((ch_returncode = insertfunc(DEF(47),DEF(64),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* move 4.6 47 */
  (*(REF(4)DOT(6).tsdr)->finalize)(REF(4)DOT(6).value,F_DISCARD,sched);
  REF(4)DOT(6) = REF(47);
  REF(47).tsdr = & dr_bottom;
/* return 4 */
  if (ch_caller = do_return(REF(4).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(4).value);
  REF(4).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c185:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
